function [Qsub,MEsub]=buildsubcells(Q,ME,n,stype) % vectorized version 
% n number of subdivision in each direction 
  if ~fc_tools.comp.isOctave && verLessThan('matlab','R2016b')
    trans=@(Z,dims) repmat(Z,dims);
  else
    trans=@(Z,dims) Z;
  end
  d=size(Q,1);nME=size(ME,2);
  Ohref=OrthMesh(d,n,'type',stype);
  qref=Ohref.Mesh.q;
  nqref=Ohref.Mesh.nq;
  meref=Ohref.Mesh.me;
  nmeref=Ohref.Mesh.nme;
  A=reshape(repmat(Q(:,ME(1,:)),[nqref,1]),[d,nqref*nME]);
  B=reshape(repmat(Q(:,ME(end,:)),[nqref,1]),[d,nqref*nME]);
  Qref=repmat(qref,[1,nME]);
  Qsub=A+(B-A).*Qref;
  MEref=repmat(meref,[1,1,nME]);
  Z=reshape(0:nqref:(nqref*nME-1),[1,1,nME]);
  Z=trans(Z,[size(MEref,1) size(MEref,2) 1]);
  if strcmp(stype,'simplicial')
    MEsub=reshape(MEref+Z,[d+1,nME*nmeref]);
  else
    MEsub=reshape(MEref+Z,[2^d,nME*nmeref]);
  end
end
